
        subroutine pesnh3p(cart,vpot)
!-->input:
!-->cart1(:,1) is cartesian coordinates for N
!-->cart1(:,2) is cartesian coordinates for H1
!-->cart1(:,3) is cartesian coordinates for H2
!-->cart1(:,4) is cartesian coordinates for H3
!-->the unit is in Angstrom

!-->output: vpot is the potential energy in a.u.
        implicit real*8(a-h,o-z)
        real*8 c(3,4),bond(6),charge(2)
        integer lxc
! convert cartesian to internal coordinate  
        call cartobond(cart,bond,br,bnh3,rh2,rnh,rb1,rb2)
        call before_vpes(bond,lxc,rha,rhb,rh3)
!        print*,'bond',br,rh2,bnh3        
        if (lxc.eq.-1) then 
          vf=120d0
        else 
         call getpot(bond,vf)
!          vf=(vf+55.83805526d0)*627.51d0
        endif
! v2 is the molecular interaction potential        
        if (rnh.lt.4.and.br.gt.5.and.rb1.gt.3.and.rb2.gt.3) then
        call peshh(rh2,vhh)
        call pesnh(rnh,vnh,1)
        call pesnh(rnh,charge(1),2)
        call pesnh(rnh,charge(2),3)
        call interaction(cart,charge,qq,qid)
        v2=vhh+vnh+qq*627.51d0+qid*627.51d0
        switch1=(1-tanh(3*(br-7.0d0)))/2
        vpot=switch1*vf+(1-switch1)*v2
        else if (bnh3.lt.5.and.rnh.gt.4) then
        call pesh3p(rha,rhb,rh3,vh3)
        rr3=bnh3/0.529177d0
        v3=-0.5*7.46166d0*627.51d0/(rr3**4)+vh3-21.935d0
        switch2=(1-tanh(3*(bnh3-6.0d0)))/2
        vpot=switch2*vf+(1-switch2)*v3
!        print*,vf,v3,rha,rhb,rh3
        else
          vpot=vf
        endif

        end subroutine pesnh3p

        subroutine cartobond(cart,bond,br,bnh3,rh2,rnh,rb1,rb2)

!-->input:
!-->cart1(:,1) is cartesian coordinates for N
!-->cart1(:,2) is cartesian coordinates for H1
!-->cart1(:,3) is cartesian coordinates for H2
!-->cart1(:,4) is cartesian coordinates for H3
!-->the unit is in Angstrom
!                                     
!                          H2           
!           N              /          H2    
!          /--------------/             \  
!         /              /               \
!        /              H3                N-----H1 - - - - H3
!       H1                             
!        
!-->output: bond(6)
!-->bond(1):NH1, bond(2):NH2, bond(3):NH3, bond(4):H1H2, bond(5):H1H3
!-->bond(6):H2H3
        implicit real*8(a-h,o-z)
        real*8 cart(3,4),bond(6),bvec(3,6)   
        real*8 cart1(3,4),bond1(3),bvec1(3,3),bvec2(3,1)
        integer ind(1)
         cart1=cart                                        

        bvec(:,1)=cart1(:,2)-cart1(:,3)          !--> H1-H2       
        bvec(:,2)=cart1(:,2)-cart1(:,4)          !--> H1-H3       
        bvec(:,3)=cart1(:,2)-cart1(:,1)          !--> H1-N       
        bvec(:,4)=cart1(:,3)-cart1(:,4)          !--> H2-H3       
        bvec(:,5)=cart1(:,3)-cart1(:,1)          !--> H2-N       
        bvec(:,6)=cart1(:,4)-cart1(:,1)          !--> H3-N       
        bvec1(:,1)=cart1(:,2)/2+cart1(:,3)/2-cart1(:,1)
        bvec1(:,2)=cart1(:,2)/2+cart1(:,4)/2-cart1(:,1)
        bvec1(:,3)=cart1(:,3)/2+cart1(:,4)/2-cart1(:,1)
        bvec2(:,1)=(cart1(:,2)+cart1(:,3)+cart1(:,4))/3-cart1(:,1)
        do i=1,6
         bond(i)=dsqrt(dot_product(bvec(:,i),bvec(:,i)))         
        enddo

        do i=1,3
         bond1(i)=dsqrt(dot_product(bvec1(:,i),bvec1(:,i)))         
        enddo
         
         bnh3=dsqrt(dot_product(bvec2(:,1),bvec2(:,1)))         

        br=maxval(bond1)
        ind=maxloc(bond1)

        if (ind(1).eq.1) then
          rh2=bond(1)
          rnh=bond(6)
          rb1=bond(3)
          rb2=bond(5)
        else if (ind(1).eq.2) then
          rh2=bond(2)
          rnh=bond(5)
          rb1=bond(3)
          rb2=bond(6)
        else if (ind(1).eq.3) then
          rh2=bond(4)
          rnh=bond(3)
          rb1=bond(5)
          rb2=bond(6)
        endif

        end

        subroutine before_vpes(rbond,lxc,rha,rhb,rh3)
        implicit real*8(a-h,o-z)
        real*8 rbond(6),rhh(3),rnh(3)
        integer ind(1)

        lxc=0

        rnh(1)=rbond(3)
        rnh(2)=rbond(5)
        rnh(3)=rbond(6)
        rhh(1)=rbond(1)
        rhh(2)=rbond(2)
        rhh(3)=rbond(4)
        rh3=maxval(rhh)
        ind=maxloc(rhh)
        if (ind(1).eq.1) then
         rha=rhh(2)
         rhb=rhh(3)
        else if (ind(1).eq.2) then
         rha=rhh(1)
         rhb=rhh(3)
        else if (ind(1).eq.3) then
         rha=rhh(2)
         rhb=rhh(1)
        endif
! remove some unphysical points  
       do i=1,3
         if (rhh(i).lt.0.4d0) then
           lxc=-1
           write(*,'(a5,3f7.3)')'rhh:',rhh
         return
         endif
       enddo

       do i=1,3
         if (rnh(i).lt.0.65d0) then
           lxc=-1
           write(*,'(3f7.3)')rnh
         return
         endif
       enddo

        rhht=rhh(1)+rhh(2)+rhh(3)
       
       if (rhht.lt.1.5d0) then
         lxc=-1
         return
       endif

! the reactant region
!       if (rb1.gt.3d0.and.rb2.gt.3d0.and.rh2.gt.1.5d0) then
!         lxc=-1
!         return
!       endif 
!       ro=roh(3)+roh(4)
!       if (ro.gt.2.4d0) then
!         lxc=-1
!         return
!       endif
      end

!----- molecular interaction potential ----------
        subroutine interaction(cart,charge,qq,qid)
        Implicit Real*8 (A-H,O-Z)
        dimension cart(3,4),c(3,7),v1(3),v2(3),v3(3),charge(2)
        dimension b(3),bvec(3,3)
        integer indc(1)
        pi=3.14159265359d0
        qurd=0.63d0*0.743475d0
        polar=0.81d0*6.78333d0
        aniso=0.314d0*6.78333d0

        do i=1,5
         c(:,i)=cart(:,i)
        enddo

        bvec(:,1)=c(:,2)-c(:,1)
        bvec(:,2)=c(:,3)-c(:,1)
        bvec(:,3)=c(:,4)-c(:,1)

        do i=1,3
         b(i)=dsqrt(dot_product(bvec(:,i),bvec(:,i)))
        enddo 
        bc=minval(b)
        indc=minloc(b)

        if (indc(1).eq.1) then
        c(:,6)=0.5*(c(:,3)+c(:,4))
        c(:,7)=charge(1)*c(:,1)+charge(2)*c(:,2)
        v1(:)=c(:,3)-c(:,4)
        v2(:)=c(:,3)-c(:,7)
        v3(:)=c(:,6)-c(:,7)
        else if (indc(1).eq.2) then
        c(:,6)=0.5*(c(:,2)+c(:,4))
        c(:,7)=charge(1)*c(:,1)+charge(2)*c(:,3)
        v1(:)=c(:,2)-c(:,4)
        v2(:)=c(:,2)-c(:,7)
        v3(:)=c(:,6)-c(:,7)
        else if (indc(1).eq.3) then
        c(:,6)=0.5*(c(:,2)+c(:,3))
        c(:,7)=charge(1)*c(:,1)+charge(2)*c(:,4)
        v1(:)=c(:,3)-c(:,2)
        v2(:)=c(:,3)-c(:,7)
        v3(:)=c(:,6)-c(:,7)
        endif
!        write(11,*),c(:,7)
        r1=dsqrt(dot_product(v1,v1))/2
        r2=dsqrt(dot_product(v2,v2))
        r3=dsqrt(dot_product(v3,v3))
        cth=(r2**2-r1**2-r3**2)/(2*r1*r3)
        if (cth.lt.0.d0) cth = -cth

        r3=r3/0.529177d0
        qq=0.5*qurd*(3*cth**2-1)/(r3**3)
        qid=-0.5*polar*(1+aniso/polar/3*(3*cth**2-1))/(r3**4)

!        write(11,'(4f8.3,3f16.8)') r1,r2,r3,cth,qq*219475d0,
!     *                             qid*219475d0,(qq+qid)*219475d0
        end

! spline H2 and HO+ 
      subroutine potreadhh
      implicit real*8(a-h,o-z)
      parameter(nr=31)
      common /hhdata/rhh(nr),ve(nr)

      rhh(1) =  0.40d0
      rhh(2) =  0.45d0
      rhh(3) =  0.50d0
      rhh(4) =  0.55d0
      rhh(5) =  0.60d0
      rhh(6) =  0.65d0
      rhh(7) =  0.70d0 
      rhh(8) =  0.742d0 
      rhh(9) =  0.80d0
      rhh(10) =  0.90d0
      rhh(11) =  1.00d0
      rhh(12) =  1.10d0
      rhh(13) =  1.20d0
      rhh(14) =  1.30d0
      rhh(15) =  1.40d0
      rhh(16) =  1.50d0
      rhh(17) =  1.60d0
      rhh(18) =  1.70d0
      rhh(19) =  1.80d0
      rhh(20) =  1.90d0
      rhh(21) =  2.00d0
      rhh(22) =  2.20d0
      rhh(23) =  2.40d0
      rhh(24) =  2.60d0
      rhh(25) =  2.80d0
      rhh(26) =  3.00d0
      rhh(27) =  3.20d0
      rhh(28) =  3.40d0
      rhh(29) =  3.60d0
      rhh(30) =  4.00d0
      rhh(31) =  5.00d0

      ve(1) = 121.08007212d0
      ve(2) =  74.84596991d0
      ve(3) =  44.18795857d0
      ve(4) =  24.17610618d0
      ve(5) =  11.60118229d0
      ve(6) =   4.30536825d0
      ve(7) =   0.79861019d0
      ve(8) =   0.00000000d0
      ve(9) =   1.24001327d0
      ve(10) =  7.53103948d0
      ve(11) = 16.72922539d0
      ve(12) = 27.15805253d0
      ve(13) = 37.83389271d0
      ve(14) = 48.20625650d0
      ve(15) = 57.86057315d0
      ve(16) = 66.73842776d0
      ve(17) = 74.49832309d0
      ve(18) = 81.22300891d0
      ve(19) = 86.93146110d0
      ve(20) = 91.68403359d0
      ve(21) = 95.53590960d0
      ve(22) =101.13752822d0
      ve(23) =104.57229833d0
      ve(24) =106.59551607d0
      ve(25) =107.75602679d0
      ve(26) =108.41107820d0
      ve(27) =108.77766327d0
      ve(28) =108.98210603d0
      ve(29) =109.09616224d0
      ve(30) =109.14361330d0
      ve(31) =109.16568461d0


      end

      subroutine peshh(r1,v)
      IMPLICIT REAL*8(A-H,O-Z)
      parameter (pi= 3.14159265358979d0,rbohr=0.5291771d0)
        if (r1.gt.5.0) r1=5.0d0
        call splinehh(r1,v)
      end

      subroutine splinehh(ra,ysp)
      implicit real*8(a-h,o-z)
      parameter (nr=31)
      parameter (m=100,n=100,l=100)
      dimension xt(m)
      dimension y(m),y2(l)
      common /hhdata/rhh(nr),ve(nr)
      data dy1,dyn/1.0d30,1.0d30/
      nr1=0
      do 2 i=1,nr
        nr1=nr1+1
        xt(nr1)=rhh(i)
        y(nr1)=ve(i)
 2    continue
      call spline(xt,y,nr1,dy1,dyn,y2)
      call splint(xt,y,y2,nr1,ra,y1)
 22   continue
      ysp=y1
       end

      subroutine potreadnh
      implicit real*8(a-h,o-z)
      parameter(nr=26)
      common /nhdata/rnh(nr),ve1(nr),ch(nr,2)

          rnh(1) =      0.60d0
          rnh(2) =      0.65d0
          rnh(3) =      0.70d0
          rnh(4) =      0.75d0
          rnh(5) =      0.80d0
          rnh(6) =      0.85d0
          rnh(7) =      0.90d0
          rnh(8) =      0.95d0
          rnh(9) =      1.00d0
          rnh(10) =     1.092d0
          rnh(11) =     1.20d0
          rnh(12) =     1.30d0
          rnh(13) =     1.40d0
          rnh(14) =     1.50d0
          rnh(15) =     1.60d0
          rnh(16) =     1.70d0
          rnh(17) =     1.80d0
          rnh(18) =     2.00d0
          rnh(19) =     2.20d0
          rnh(20) =     2.40d0
          rnh(21) =     2.60d0
          rnh(22) =     2.80d0
          rnh(23) =     3.00d0
          rnh(24) =     3.20d0
          rnh(25) =     3.60d0
          rnh(26) =     4.00d0

          ve1( 1) =   273.9521976d0
          ve1( 2) =   188.2364086d0
          ve1( 3) =   126.9844861d0
          ve1( 4) =   83.46472859d0
          ve1( 5) =   52.87902523d0
          ve1( 6) =   31.76689681d0
          ve1( 7) =   17.60786785d0
          ve1( 8) =   8.408197890d0
          ve1( 9) =   3.232021631d0
          ve1(10) =           0.0d0
          ve1(11) =   2.550696373d0
          ve1(12) =   7.887267317d0
          ve1(13) =   14.39001539d0
          ve1(14) =   21.19022831d0
          ve1(15) =   27.84323993d0
          ve1(16) =   34.13421594d0
          ve1(17) =   39.97037269d0
          ve1(18) =   50.18021767d0
          ve1(19) =   58.48130901d0
          ve1(20) =   65.00734398d0
          ve1(21) =   69.93476586d0
          ve1(22) =   75.33611466d0
          ve1(23) =   78.40886797d0
          ve1(24) =   80.45544791d0
          ve1(25) =   82.57283608d0
          ve1(26) =   83.39211941d0

           ch(1,:) =  (/ 0.83185d0,  0.16815d0 /)
           ch(2,:) =  (/ 0.80381d0,  0.19619d0 /)
           ch(3,:) =  (/ 0.78084d0,  0.21916d0 /)
           ch(4,:) =  (/ 0.75805d0,  0.24195d0 /)
           ch(5,:) =  (/ 0.73393d0,  0.26607d0 /)
           ch(6,:) =  (/ 0.70992d0,  0.29008d0 /)
           ch(7,:) =  (/ 0.68878d0,  0.31122d0 /)
           ch(8,:) =  (/ 0.66279d0,  0.33721d0 /)
           ch(9,:) =  (/ 0.64062d0,  0.35938d0 /)
           ch(10,:) = (/ 0.60221d0,  0.39779d0 /)
           ch(11,:) = (/ 0.56032d0,  0.43968d0 /)
           ch(12,:) = (/ 0.52435d0,  0.47565d0 /)
           ch(13,:) = (/ 0.49529d0,  0.50471d0 /)
           ch(14,:) = (/ 0.48043d0,  0.51957d0 /)
           ch(15,:) = (/ 0.46975d0,  0.53025d0 /)
           ch(16,:) = (/ 0.45596d0,  0.54404d0 /)
           ch(17,:) = (/ 0.44681d0,  0.55319d0 /)
           ch(18,:) = (/ 0.43992d0,  0.56008d0 /)
           ch(19,:) = (/ 0.43977d0,  0.56023d0 /)
           ch(20,:) = (/ 0.44064d0,  0.55936d0 /)
           ch(21,:) = (/ 0.44127d0,  0.55873d0 /)
           ch(22,:) = (/ 0.44127d0,  0.55873d0 /)
           ch(23,:) = (/ 0.44127d0,  0.55873d0 /)
           ch(24,:) = (/ 0.44127d0,  0.55873d0 /)
           ch(25,:) = (/ 0.44127d0,  0.55873d0 /)
           ch(26,:) = (/ 0.44127d0,  0.55873d0 /)
        
      end

      subroutine pesnh(r1,v,iop)
      IMPLICIT REAL*8(A-H,O-Z)
      parameter (pi= 3.14159265358979d0,rbohr=0.5291771d0)
        if (r1.gt.4.0) r1=4.0d0
        call splinenh(r1,v,iop)
      end

      subroutine splinenh(ra,ysp,iop)
      implicit real*8(a-h,o-z)
      parameter (nr=26)
      parameter (m=100,n=100,l=100)
      dimension xt(m)
      dimension y(m),y2(l)
      common /nhdata/rnh(nr),ve1(nr),ch(nr,2)
      data dy1,dyn/1.0d30,1.0d30/
      nr1=0
      do 2 i=1,nr
        nr1=nr1+1
        xt(nr1)=rnh(i)
        if (iop.eq.1) y(nr1)=ve1(i)
        if (iop.eq.2) y(nr1)=ch(i,1)
        if (iop.eq.3) y(nr1)=ch(i,2)
 2    continue
      call spline(xt,y,nr1,dy1,dyn,y2)
      call splint(xt,y,y2,nr1,ra,y1)
 22   continue
      ysp=y1
       end
C##################################################################
C# SPLINE ROUTINES
C#            Numerical recipes in fortran
C#            Cambrige University Press
C#            York, 2nd edition, 1992.
C##################################################################
      SUBROUTINE splint(xa,ya,y2a,n,x,y)
      implicit double precision  (a-h,o-z)
      DIMENSION xa(n),y2a(n),ya(n)
      klo=1
      khi=n
 1    if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.0d0) write(6,*) 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**
     *2)/6.0d0
      return
      END
C##############################################################################

      SUBROUTINE spline(x,y,n,yp1,ypn,y2)
      implicit double precision  (a-h,o-z)
      DIMENSION x(n),y(n),y2(n)
      PARAMETER (NMAX=100)
      DIMENSION u(NMAX)
      if (yp1.gt..99d30) then
        y2(1)=0.0d0
        u(1)=0.0d0
      else
        y2(1)=-0.5d0
        u(1)=(3.0d0/(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      do 11 i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2.0d0
        y2(i)=(sig-1.0d0)/p
        u(i)=(6.0d0*((y(i+1)-y(i))/(x(i+
     *1)-x(i))-(y(i)-y(i-1))/(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*
     *u(i-1))/p
11    continue
      if (ypn.gt..99d30) then
        qn=0.0d0
        un=0.0d0
      else
        qn=0.5d0
        un=(3.0d0/(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.0d0)
      do 12 k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
      return
      END



!-->  program to get potential energy for a given geometry after NN fitting
!-->  global variables are declared in this module
       module nnparam
       implicit none
!       integer,parameter::nbasis=20,ndim=6,natom=4
       integer,parameter::ninput=22,nhid=2,noutput=1
       integer,parameter::ifunc=1,nwe=1121,npes=3
       integer nlayer,nodemax,nscale
       integer, allocatable::nodes(:)
!        integer, allocatable::nterm(:),nindex(:,:,:)
       real*8, allocatable::weight(:,:,:,:),bias(:,:,:)
       real*8, allocatable::pdel(:,:),pavg(:,:)
       end module nnparam

!-->  read NN weights and biases from matlab output
!-->  weights saved in 'weights.txt'
!-->  biases saved in 'biases.txt'
!-->  one has to call this subroutine once and only once before calling the getpot() subroutine
       subroutine pes_init
       use nnparam
       implicit none
       integer i,ipes,iwe,inode1,inode2,ilay1,ilay2
       character*1 itoc1

!       open(111,file='weights.txt')
!       open(222,file='biases.txt')
!       read(111,*)ninput,nhid,noutput
!       read(111,*)(nodes(ihid),ihid=2,nhid+1)
!       read(111,*)ifunc,nwe

        nscale=ninput+noutput
        nlayer=nhid+2
        allocate(nodes(nlayer),pdel(nscale,npes),pavg(nscale,npes))
        nodes(1)=ninput
        nodes(2)=20
        nodes(3)=30
        nodes(nlayer)=noutput
        nodemax=0
        do i=1,nlayer
        nodemax=max(nodemax,nodes(i))
        enddo
        allocate(weight(nodemax,nodemax,2:nlayer,npes),
     &   bias(nodemax,2:nlayer,npes))

        do ipes=1,npes
        open(4,file='weights.txt-'//itoc1(ipes))
        open(7,file='biases.txt-'//itoc1(ipes))
        read(4,*)(pdel(i,ipes),i=1,nscale)
        read(4,*)(pavg(i,ipes),i=1,nscale)
!        read(111,*)(pdel(i),i=1,nscale)
!        read(111,*)(pavg(i),i=1,nscale)

        iwe=0
        do ilay1=2,nlayer
        ilay2=ilay1-1
        do inode1=1,nodes(ilay1)
        do inode2=1,nodes(ilay2)

        read(4,*)weight(inode2,inode1,ilay1,ipes)
        iwe=iwe+1
!        write(333,'(a16,i2,a2,i2,a2,i2,a3,f20.16,a3)')'weight(',inode2,
!     &        ', ',inode1,', ',ilay1,') =',weight(inode2,inode1,ilay1),
!     &        'd0 '
        enddo
        read(7,*)bias(inode1,ilay1,ipes)
!        write(333,'(a19,i2,a2,i2,a3,f20.16,a3)')'bias(',inode1,', ',
!     &          ilay1,') =',bias(inode1,ilay1),'d0 '
        iwe=iwe+1
        enddo
        enddo


        if (iwe.ne.nwe) then
           write(*,*)'provided number of parameters ',nwe
           write(*,*)'actual number of parameters ',iwe
           write(*,*)'nwe not equal to iwe, check input files or code'
           stop
        endif
        close(4)
        close(7)
        enddo

        return
        end subroutine pes_init

      function itoc1(i)
      character*1 itoc1
      integer one
      one=mod(i,10)
      itoc1(1:1)=char(48+one)
      return
      end

! accelerate pertumation invariant polynomial calculation
      subroutine bemsav(x,p)
      implicit none
      real*8,dimension(1:6),intent(in)::x
      real*8,dimension(0:22),intent(out)::p
      ! ::::::::::::::::::::
      real*8,dimension(0:29)::m
      call evmono(x,m)
      call evpoly(m,p)
      return
      end subroutine bemsav
 
      subroutine evmono(x,m)
      implicit none
      real*8,dimension(1:6),intent(in)::x
      real*8,dimension(0:29),intent(out)::m
 
      m(0)=1.D0
      m(1)=x(6)
      m(2)=x(5)
      m(3)=x(3)
      m(4)=x(4)
      m(5)=x(2)
      m(6)=x(1)
      m(7)=m(1)*m(2)
      m(8)=m(1)*m(3)
      m(9)=m(2)*m(3)
      m(10)=m(3)*m(4)
      m(11)=m(2)*m(5)
      m(12)=m(1)*m(6)
      m(13)=m(4)*m(5)
      m(14)=m(4)*m(6)
      m(15)=m(5)*m(6)
      m(16)=m(1)*m(9)
      m(17)=m(1)*m(10)
      m(18)=m(2)*m(10)
      m(19)=m(1)*m(11)
      m(20)=m(3)*m(11)
      m(21)=m(2)*m(12)
      m(22)=m(3)*m(12)
      m(23)=m(2)*m(13)
      m(24)=m(3)*m(13)
      m(25)=m(1)*m(14)
      m(26)=m(3)*m(14)
      m(27)=m(1)*m(15)
      m(28)=m(2)*m(15)
      m(29)=m(4)*m(15)
 
      return
      end subroutine evmono
 
      subroutine evpoly(m,p)
      implicit none
      real*8,dimension(0:29),intent(in)::m
      real*8,dimension(0:22),intent(out)::p
 
      p(0)=m(0)
      p(1)=m(1)+m(2)+m(3)
      p(2)=m(4)+m(5)+m(6)
      p(3)=m(7)+m(8)+m(9)
      p(4)=m(10)+m(11)+m(12)
      p(5)=p(1)*p(2)-p(4)
      p(6)=m(13)+m(14)+m(15)
      p(7)=p(1)*p(1)-p(3)-p(3)
      p(8)=p(2)*p(2)-p(6)-p(6)
      p(9)=m(16)
      p(10)=m(17)+m(18)+m(19)+m(20)+m(21)+m(22)
      p(11)=p(2)*p(3)-p(10)
      p(12)=m(23)+m(24)+m(25)+m(26)+m(27)+m(28)
      p(13)=m(29)
      p(14)=p(1)*p(6)-p(12)
      p(15)=p(1)*p(3)-p(9)-p(9)-p(9)
      p(16)=p(1)*p(4)-p(10)
      p(17)=p(2)*p(7)-p(16)
      p(18)=p(2)*p(4)-p(12)
      p(19)=p(1)*p(8)-p(18)
      p(20)=p(2)*p(6)-p(13)-p(13)-p(13)
      p(21)=p(1)*p(7)-p(15)
      p(22)=p(2)*p(8)-p(20)
 
      return
      end subroutine evpoly


        function tranfun(x,ifunc)
        implicit none
        integer ifunc
        real*8 tranfun,x
c    ifunc=1, transfer function is hyperbolic tangent function, 'tansig'
c    ifunc=2, transfer function is log sigmoid function, 'logsig'
c    ifunc=3, transfer function is pure linear function, 'purelin'. It is imposed to the output layer by default
        if (ifunc.eq.1) then
        tranfun=tanh(x)
        else if (ifunc.eq.2) then
        tranfun=1d0/(1d0+exp(-x))
        else if (ifunc.eq.3) then
        tranfun=x
        endif
        return
        end


c *******************************
      real*8 function bndlen(n,i1,i2,xat,yat,zat)

c ..................................................
c  PURPOSE: return bond length between atoms i1 & i2
c
c  INPUT:   i1,i2 - indices of 2 atoms
c
c ..................................................
      implicit real*8(a-h,o-z)
      dimension XAT(n),YAT(n),ZAT(n)

      bndlen=dsqrt( (xat(i1)-xat(i2))**2
     #            +(yat(i1)-yat(i2))**2+(zat(i1)-zat(i2))**2 )

      return
      end

c **********************************
      real*8 function bndang(n,i1,i2,i3,xat,yat,zat)

c .........................................
c  PURPOSE: return bond angle (i1,i2,i3)
c           [in rad.] with 'i2' as vertex
c
c  INPUT:   i1,i2,i3 - indices of 3 atoms
c .........................................
      implicit real*8(a-h,o-z)
      dimension XAT(n),YAT(n),ZAT(n)

      h1=xat(i2)
      h2=yat(i2)
      h3=zat(i2)
      x1=xat(i1)-h1
      x2=yat(i1)-h2
      x3=zat(i1)-h3
      y1=xat(i3)-h1
      y2=yat(i3)-h2
      y3=zat(i3)-h3

      x=x1*x1+x2*x2+x3*x3
      y=y1*y1+y2*y2+y3*y3
      u=x*y

      if (u.ne.0.0) then

        a=(x1*y1+x2*y2+x3*y3)/dsqrt(u)
        a=max(a,-1.0)
        a=min(a,1.0)
        bndang=acos(a)
        return
      else
        write (*,'(a,3i5)')' valang> Error in coordinates of atoms
     #: '
     #                     ,i1,i2,i3
        stop
      endif

      end

c *************************************
      real*8 function dihedr(n,i1,i2,i3,i4,xat,yat,zat)

c .............................................
c  PURPOSE: return dihedral angle (i1,i2,i3,i4) [in rad.]
c
c  INPUT:   i1,i2,i3,i4 - indices of four atoms
c
c  CALLS:   none
c .............................................
      implicit real*8(a-h,o-z)
      dimension XAT(n),YAT(n),ZAT(n)

      x1=xat(i2)-xat(i1)
      y1=yat(i2)-yat(i1)
      z1=zat(i2)-zat(i1)
      x2=xat(i3)-xat(i2)
      y2=yat(i3)-yat(i2)
      z2=zat(i3)-zat(i2)
      ux1=y1*z2-z1*y2
      uy1=z1*x2-x1*z2
      uz1=x1*y2-y1*x2
      x1=xat(i4)-xat(i3)
      y1=yat(i4)-yat(i3)
      z1=zat(i4)-zat(i3)
      ux2=z1*y2-y1*z2
      uy2=x1*z2-z1*x2
      uz2=y1*x2-x1*y2

      u1=ux1*ux1+uy1*uy1+uz1*uz1
      u2=ux2*ux2+uy2*uy2+uz2*uz2
      u=u1*u2

      if (u.ne.0.0) then
        a=(ux1*ux2+uy1*uy2+uz1*uz2)/dsqrt(u)
        a=max(a,-1.0)
        a=min(a,1.0)
        dihedr=acos(a)
        if (ux1*(uy2*z2-uz2*y2)+uy1*(uz2*x2-ux2*z2)+
     #      uz1*(ux2*y2-uy2*x2).lt.0.0) dihedr =-dihedr
        return
      else
!        write (*,'(a,4i5)')' dihedr> Error in coordinates of atoms
!     #: '
!     #                     ,i1,i2,i3,i4
!        stop
      dihedr=acos(0.0d0)
      endif

      end

        subroutine getpot(bond,vpot)
        use nnparam
        implicit none
        integer i,ipes,inode1,inode2,ilay1,ilay2,nbasis
        real*8 x(ninput),y(nodemax,nlayer),vpot,pesnn(npes)
        real*8 x1(23),alpha,bond(6),xbond(6)
        real*8, external :: tranfun
       
        nbasis=23
        alpha=2.0d0
        do i=1,6
          xbond(i) = exp(-bond(i)/(0.529177d0*alpha))
        enddo
        call bemsav(xbond,x1)
        do i=1,22
          x(i)=x1(i+1)
        enddo

        vpot=0.d0
        do ipes=1,npes
!-->....set up the normalized input layer
        do i=1,ninput
        y(i,1)=(x(i)-pavg(i,ipes))/pdel(i,ipes)
        enddo

!-->....evaluate the hidden layer
        do ilay1=2,nlayer-1
        ilay2=ilay1-1
        do inode1=1,nodes(ilay1)
        y(inode1,ilay1)=bias(inode1,ilay1,ipes)
        do inode2=1,nodes(ilay2)
        y(inode1,ilay1)=y(inode1,ilay1)+y(inode2,ilay2)
     &*weight(inode2,inode1,ilay1,ipes)
        enddo
        y(inode1,ilay1)=tranfun(y(inode1,ilay1),ifunc)
        enddo
        enddo

!-->....now evaluate the output
        ilay1=nlayer
        ilay2=ilay1-1
        do inode1=1,nodes(ilay1)
        y(inode1,ilay1)=bias(inode1,ilay1,ipes)
        do inode2=1,nodes(ilay2)
        y(inode1,ilay1)=y(inode1,ilay1)+y(inode2,ilay2)
     &*weight(inode2,inode1,ilay1,ipes)
        enddo
!-->....the transfer function is linear y=x for output layer
!-->....so no operation is needed here
        enddo

!-->....the value of output layer is the fitted potntial 
        pesnn(ipes)=y(nodes(nlayer),nlayer)*pdel(nscale,ipes)+
     &              pavg(nscale,ipes)
        vpot=vpot+pesnn(ipes)
        
        enddo
!        write(111,'(3f16.4)')pesnn(1),pesnn(2),pesnn(3)
!-->....average of potential
        vpot=vpot/npes

        return
        end

     
      subroutine potreadh3p
      implicit real*8(a-h,o-z)
      parameter (pi=3.141592653589793d0)    
      parameter (ncr=14,nth=8)
      common /pes/pesmin,rh(ncr),thh(ncr,ncr,nth),
     & ve(ncr,ncr,nth),ves(ncr,ncr,nth),ind(ncr,ncr)
      dimension xt(100),y(100),y2(100)
      open(98,file='h3p.txt')
        vcut=100d0
        pesmin=vmin
        do i=1,ncr
        do j=1,i
        do k=1,nth
        read(98,*)ra1,ra2,th1,ve1
!        write(99,'(3f8.2,f20.8)')ra1,ra2,th1,ve1

        rh(i)=ra1
        thh(i,j,k)=th1
        thh(j,i,k)=th1
        ve(i,j,k)=ve1
        if (ve(i,j,k).gt.vcut) ve(i,j,k)=vcut
!	if (ve(i,j,k).lt.pesmin.and.(thh(i,j,k).gt.60.)) then
!	pesmin=ve(i,j,k)
!	r1m=ra1
!	r2m=ra2
!        th1m=th1
!	endif
      ve(j,i,k)=ve(i,j,k) 
      end do
      end do
      end do
      close(98)
!      write(99,*)' rh',(rh(i),i=1,ncr)

       do i=1,ncr
       do j=1,ncr
        nh=0
       do k=1,nth
        nh=nh+1
        xt(nh)=thh(i,j,k)
        y(nh)=ve(i,j,k)
       enddo
        call spline(xt,y,nh,0.d30,0.d30,y2)
        do ik=1,nh
        ves(i,j,ik)=y2(ik)
        enddo
       enddo;enddo
1004    format(3i5,f15.8) 

      end



      subroutine pesh3p(r1,r2,r3,v)
      implicit real*8(a-h,o-z)
      parameter (ncr=14,nth=8)    
      common /pes/pesmin,rh(ncr),thh(ncr,ncr,nth),
     & ve(ncr,ncr,nth),ves(ncr,ncr,nth),ind(ncr,ncr)
       parameter (rbohr=0.5291771)
       parameter (pi=3.141592653589793d0)
       cth=(r1**2+r2**2-r3**2)/(2*r1*r2)
       if(cth.gt.1.0d0)cth=1.0d0
       if(cth.lt.-1.0d0)cth=-1.0d0
        th1=dacos(cth)*180/pi
        if (r1.lt.0.6) r1=0.6
        if (r2.lt.0.6) r2=0.6
        if (r1.gt.1.6) r1=1.6
        if (r2.gt.1.6) r2=1.6
        if (th1.gt.180d0) th1=180d0
        if (th1.lt.60d0) th1=60d0
        CALL SPl3(r1,r2,th1,v,1)
      end


       subroutine spl3(r1,r2,th,v,iop)
       implicit real*8(a-h,o-z)
       parameter (ncr=14,nth=8)
       parameter (m=100,n=100,l=100)
       dimension xt(m)  
       dimension dty(l),ddty(l),s1(1),ds1(1),dds1(1),h1(l)
       dimension dny(n),ddny(n),s2(1),ds2(1),dds2(1),h2(n)
       dimension dhy(m),ddhy(m),s3(1),ds3(1),dds3(1),h3(m)
       dimension y(m),ss(m),sss(m),y2(l)
      common /pes/pesmin,rh(ncr),thh(ncr,ncr,nth),
     & ve(ncr,ncr,nth),ves(ncr,ncr,nth),ind(ncr,ncr)
       data dy1,dyn/1.0d30,1.0d30/
       do 20 i=1,ncr
       do 10 j=1,ncr
         nh=0
       do 2 k=1,nth
        nh=nh+1
        xt(nh)=thh(i,j,k)
        y(nh)=ve(i,j,k)
        y2(nh)=ves(i,j,k)
!        write(*,*)rh(i),rh(j),xt(nh),ve(i,j,k)
   2   continue
        r3a=th
        if (th.lt.xt(1)) r3a=xt(1)
!	call spline(xt,y,nh,dy1,dyn,y2)
        call splint(xt,y,y2,nh,r3a,y3)
 22     continue
        ss(j)=y3
   10   continue
   
        nr=0
       do 5 j=1,ncr
        nr=nr+1
        xt(nr)=rh(j)
        y(nr)=ss(j)
   5   continue
        call spline(xt,y,nr,dy1,dyn,y2)
        call splint(xt,y,y2,nr,r2,yw2)
 33     continue
       sss(i)=yw2
   20    continue
  
        nr=0
        do i=1,ncr
        nr=nr+1
        xt(nr)=rh(i)
        y(nr)=sss(i)
        enddo
        call spline(xt,y,nr,dy1,dyn,y2)
        call splint(xt,y,y2,nr,r1,yw2)
   44   continue
       v=yw2
       end

