      program testpot
      implicit Real*8 (A-H,O-Z)
      real*8 cart(3,4),bond(6)
      character*32 tmp
      character*4 symb
      pi=3.14159265359d0
!-->..initialize the parameters, do this only once
      call pes_init
      call potreadhh
      call potreadnh
      call potreadh3p
        open(3,file='test.inp')
        open(2,file='test.txt')

        read(3,*)np
        print*,'np:',np
        if (np.eq.1) then
          read(3,*)nch
          read(3,*)r1s,r1l,step1
          read(3,*)r2s,r2l,step2
          read(3,*)r3s,r3l,step3
          read(3,*)r4s,r4l,step4
          read(3,*)r5s,r5l,step5
          read(3,*)r6s,r6l,step6
          do r1=r1s,r1l,step1
          do r2=r2s,r2l,step2
          do r3=r3s,r3l,step3
          do aa1=r4s,r4l,step4
          do aa2=r5s,r5l,step5
          do dd1=r6s,r6l,step6
             a1=aa1*pi/180d0
             a2=aa2*pi/180d0
             a3=pi*2-a1-a2
             d1=dd1*pi/180d0
        call channel(nch,r1,r2,r3,a1,a2,a3,d1,cart)
        call pesnh3p(cart,vpot)
        vfun=vpot     !-->energies in kcal/mol
        
        write(10,*)' 4'
        write(10,*)vfun
        write(10,*)'N',cart(:,1)
        write(10,*)'H',cart(:,2)
        write(10,*)'H',cart(:,3)
        write(10,*)'H',cart(:,4)
          
        write(2,'(6f9.3,f16.8)')r1,r2,r3,aa1,aa2,dd1,vfun  
          enddo
          enddo

          enddo
          enddo
!        write(2,'(6f9.3,f16.8)')fr1,fr2,r3,aa1,faa2,fdd1,vm  
          enddo
          enddo
        
        else 
        read(3,*)numt
        print*,numt
       rms=0
       do i=1,numt
        read(3,*)
        read(3,*)
        read(3,*)symb,cart(:,1)      
        read(3,*)symb,cart(:,2)
        read(3,*)symb,cart(:,3)
        read(3,*)symb,cart(:,4)
        call pesnh3p(cart,vpot)
        write(2,'(i4,f16.8)')i,vpot
       enddo
        endif
       close(3)
       close(3)
      end

      subroutine channel(nch,r1,r2,r3,a1,a2,a3,d1,cart) 
      Implicit Real*8 (A-H,O-Z)
      real*8 cart(3,4)
       if (nch.eq.1) then
!-----------NH+ + H2----------------
!      N1                  H3   
!      / a1                 /a2
!   r1/------------------r2/---- d1
!    /        r3          /
!   /                    H4
!  H2
           y1=r1/15d0*dsin(a1)
           y2=-r1*14d0/15d0*dsin(a1)
           x1=r1/15d0*dcos(a1)
           x2=-r1*14d0/15d0*dcos(a1)
           z1=0d0
           z2=0d0
           z3=r2/2*dsin(d1)*dsin(a2)
           z4=-r2/2*dsin(d1)*dsin(a2)
           x3=r2/2*dcos(a2)+r3
           x4=-r2/2*dcos(a2)+r3
           y3=r2/2*dcos(d1)*dsin(a2)
           y4=-r2/2*dcos(d1)*dsin(a2)

       elseif (nch.eq.2) then     
!-----------NH2+ + H----------------
!
!     H3     H2 
!      \ a1 /r1
!     r2\  /a2
!        N1------------------H4   d1
!                  r3
           y1=0
           x1=0
           z1=0
           z4=r3*sin(d1)
           x4=r3*cos(d1)
           y4=0
 
           x2=r1*cos(a2)
           y2=r1*sin(a2)
           z2=0
 
           z3=0
           x3=r2*cos(a3)
           y3=-r2*sin(a3)

       elseif (nch.eq.3) then 
!-----------N + H3+-----------
!
!     H3     H2 
!      \ a1 /r1
!     r2\  /a2
!        H4------------------N1   d1
!                  r3

           y4=0
           x4=0
           z4=0

           z1=r3*sin(d1)
           x1=r3*cos(d1)
           y1=0
 
           x2=r1*cos(a2)
           y2=r1*sin(a2)
           z2=0
 
           z3=0
           x3=r2*cos(a3)
           y3=-r2*sin(a3)
       else
         print*,'There is on such channel'
         stop
       endif    
           cart(1,1)=x1 
           cart(2,1)=y1 
           cart(3,1)=z1 
           cart(1,2)=x2 
           cart(2,2)=y2 
           cart(3,2)=z2 
           cart(1,3)=x3 
           cart(2,3)=y3 
           cart(3,3)=z3 
           cart(1,4)=x4 
           cart(2,4)=y4 
           cart(3,4)=z4
       End
